
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Battery Classes &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Nasa dataset" href="NASA.html" />
    <link rel="prev" title="Useful Dictionaries" href="main.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="current reference internal nav-link" href="#">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="NASA.html">
   Nasa dataset
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="MIT.html">
   MIT dataset
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="COIN.html">
   Tarascon's Coin dataset
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#working-with-new-datasets">
   Working with new Datasets
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="battery-classes">
<h1>Battery Classes<a class="headerlink" href="#battery-classes" title="Permalink to this headline">¶</a></h1>
<p>Each one of the modules cited next contain two sets of classes that aim to store
the cycling data of each dataset. The first set aims to open the raw data files
provided by the authors and store all of the information as is in a python
object. The second set of classes aim to clean and select data that is
proper for model training and validation, as well as storing them in a way that
the dataset creation classes can access them. They take as input the
corresponding raw battery class.</p>
<p>Usually they are structured something like this (<strong>fake class names, class
names depend on the dataset</strong>):</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># Raw data</span>
<span class="n">dataset_class</span> <span class="o">=</span> <span class="n">Raw_Dataset</span><span class="p">(</span><span class="s1">&#39;raw_data.mat&#39;</span><span class="p">)</span>
<span class="n">list_of_cycles</span> <span class="o">=</span> <span class="n">dataset_class</span><span class="o">.</span><span class="n">cycle</span>
<span class="n">cycle_class</span> <span class="o">=</span> <span class="n">dataset_class</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>    <span class="c1"># Instance of Raw_Cycle, for cycle 0</span>
<span class="n">data_class</span> <span class="o">=</span> <span class="n">cycle_class</span><span class="o">.</span><span class="n">data</span>           <span class="c1"># Instance of Raw_Data</span>
<span class="n">voltage</span> <span class="o">=</span> <span class="n">data_class</span><span class="o">.</span><span class="n">meas_v</span>             <span class="c1"># measured voltage for cycle 0</span>

<span class="c1"># Clean data</span>
<span class="n">dataset_class</span> <span class="o">=</span> <span class="n">Clean_Dataset</span><span class="p">(</span><span class="n">Raw_Dataset</span><span class="p">)</span>
<span class="n">list_cycle_couples</span> <span class="o">=</span> <span class="n">dataset_class</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="c1"># List of tuples</span>
<span class="c1"># Associated charge and discharge cycles (Clean_Cycle classes):</span>
<span class="n">charge_cycle</span><span class="p">,</span> <span class="n">discharge_cycle</span> <span class="o">=</span> <span class="n">list_cycle_couples</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">data_class</span> <span class="o">=</span> <span class="n">charge_cycle</span><span class="o">.</span><span class="n">data</span>          <span class="c1"># Clean_Data classes</span>
<span class="n">voltage</span> <span class="o">=</span> <span class="n">data_class</span><span class="o">.</span><span class="n">meas_v</span>
</pre></div>
</div>
<p>All source code has examples on how the classes should be called/initialized
for treating the data (after the <code class="docutils literal notranslate"><span class="pre">if</span> <span class="pre">__name__</span> <span class="pre">==</span> <span class="pre">'__main__':</span></code> part).</p>
<p>For new datasets, raw battery classes will invariably have to be created
according to the way the data is given (type of file etc.). New Clean Battery
Classes should probably be created for each new
dataset (though the framework is similar and can mostly be reused, with few
adaptations for the small differences between datasets).</p>
<p>The dataset with the most different structure is the Na-ion dataset, because
batteries are split into cells.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="NASA.html">Nasa dataset</a></li>
<li class="toctree-l1"><a class="reference internal" href="MIT.html">MIT dataset</a></li>
<li class="toctree-l1"><a class="reference internal" href="COIN.html">Tarascon's Coin dataset</a></li>
</ul>
</div>
<div class="section" id="working-with-new-datasets">
<span id="new-dataset"></span><h2>Working with new Datasets<a class="headerlink" href="#working-with-new-datasets" title="Permalink to this headline">¶</a></h2>
<p>If you wish to work with new datasets, you’ll have to create new raw and clean
dataset classes each time, but you can use the template
<a class="reference internal" href="Template%20Class.html"><span class="doc">Template_Classes.py</span></a> to have an idea on how to do it
(it’s easier to look directly at its source code, I think, and also look at
the other dataset classes).</p>
<p>Keep in mind that, for easier integration with other codes, you’ll have to
update:</p>
<ul class="simple">
<li><p>The <code class="docutils literal notranslate"><span class="pre">main.py</span></code> dictionaries (<a class="reference internal" href="main.html"><span class="doc">Useful Dictionaries</span></a>).</p></li>
<li><p>A few statements in <a class="reference internal" href="Report.html#Load_Save.Load_Save" title="Load_Save.Load_Save"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save()</span></code></a> and
<a class="reference internal" href="Report.html#Load_Save.Load_Save_v2" title="Load_Save.Load_Save_v2"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save_v2()</span></code></a>.</p></li>
<li><p>Probably a few <code class="docutils literal notranslate"><span class="pre">assertion</span></code> s here and there (like in
<code class="xref py py-func docutils literal notranslate"><span class="pre">dataset_joint_plot()</span></code>).</p></li>
<li><p>The path from the main folder to the clean batteries folder must have exactly
four steps, so that the codes can come back to the main project folder through
<code class="docutils literal notranslate"><span class="pre">os.chdir('../../../../')</span></code>.</p></li>
<li><p>Name the clean battery pickles as “B000X.txt”. Examples: B0001.txt, B0020.txt,
B0134.txt etc. This standard notation is important to be recognized by codes.
It can be created by: <code class="docutils literal notranslate"><span class="pre">&quot;B&quot;+str(i).zfill(4)+&quot;.txt&quot;</span></code>, with <code class="docutils literal notranslate"><span class="pre">i</span></code> being the
battery number.</p></li>
</ul>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="main.html" title="previous page">Useful Dictionaries</a>
    <a class='right-next' id="next-link" href="NASA.html" title="next page">Nasa dataset</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>